#ifndef __LOCK_SDK_H__
#define __LOCK_SDK_H__
   


// Ƭ 
enum ERROR_TYPE
{
    OPR_OK              =   1,      // ɹ
    NO_CARD			    =   -1,     // û⵽Ƭ
    NO_RW_MACHINE	    =   -2,     // û⵽
    INVALID_CARD	    =   -3,     // Ч
    CARD_TYPE_ERROR	    =   -4,     // ʹ
    RDWR_ERROR		    =   -5,     // д
    PORT_NOT_OPEN	    =   -6,     // ˿δ
    END_OF_DATA_CARD    =   -7,     // ݿ
    INVALID_PARAMETER   =   -8,     // Ч
    INVALID_OPR		    =   -9,     // Ч
    OTHER_ERROR		    =   -10,    // 
    PORT_IN_USED	    =   -11,    // ˿ѱռ
    COMM_ERROR		    =   -12,    // ͨѶ    
    ERR_CLIENT          =   -20,    // ͻ    
    ERR_NOT_REGISTERED  =   -29,    // δע
    ERR_NO_CLIENT_DATA  =   -30,     // ȨϢ
    ERR_ROOMS_CNT_OVER  =   -31,    // ˿
}; 


#ifdef __cplusplus
	extern "C" { 
#endif

/*=============================================================================
                        TP_Configuration
;
ܣ̬ʼ, ѡ/ӵ
  룺lock_type -- (ҲʹõĿƬ): 4-RF57; 5-RF50
  : 
ֵ
=============================================================================*/
int __stdcall TP_Configuration(int lock_type);

/*=============================================================================
                        TP_MakeGuestCardEx2
;
ܣͿ
  룺room_no         --  :     ַ,  "1.2.8102"
        checkin_time    --  סʱ䣺  Ԥ. ƿʱסʱ䱻ǿΪǰʱ!!!
        checkout_time   --  Ԥʱ䣺  ʱ, ַʽ "YYYY-MM-DD hh:mm:ss"
        iflags          --  Ϳѡ, һ0. iflagsĸֵָ:
        		      1:  ʾ
        		      8:  ʾƿ, ǰ(Ը֮ǰĿƬһ, һ䷢ſƬ)
        		      32: ʾһԿ, źʧЧ
        		      128: ʾ⿨Ƭסʱ(Ƭסʱ > ǰʱ, ܿ, ѡ)
        		      ֵӽ.
        		      iflags ==0, ʾᶥǰ,ˢ֮ǰĿƬʧЧ; һԿſ; ⿨Ƭסʱ
		waitMs          -- ȴſʱ(λ:)
   	
  : card_snr        -- :        ַ, Ԥ20ֽ
  1: room_no="1.2.8102", SDateTime="", EDateTime="2008-06-07 12:00:00"
        iFlags=8  !!!!!!!!(ƿ)

ֵ
˵:   RoomҪ !!  ʽ, 鿴"ͷ". û, 
        뷿. 
=============================================================================*/
int __stdcall TP_MakeGuestCardEx2(char *card_snr, char *room_no, char *checkin_time,char *checkout_time, int iflags, int waitMs);



/*=============================================================================
                        TP_ReadGuestCardEx2
;
ܣͿϢ
  룺waitMs -- ȴſʱ(λ:)
  : card_snr        --  :       ַ, Ԥ20ֽ
        room_no         --  :       ַ, Ԥ20ֽ
        checkin_time    --  סʱ䣺  ʱ, ַʽ "YYYY-MM-DD hh:mm:ss", Ԥ30ֽ
        checkout_time   --  Ԥʱ䣺  ʱ, ַʽ "YYYY-MM-DD hh:mm:ss", Ԥ30ֽ
        iFlags          --  Ƭ־ֽ
ֵ
=============================================================================*/
int __stdcall TP_ReadGuestCardEx2(char *card_snr,char *room_no, char *checkin_time, char *checkout_time, int *iFlags, int waitMs);


/*=============================================================================
                        TP_CancelCard
;
ܣעƬ/Ƭ
  : waitMs -- ȴſʱ(λ:)
  
  : card_snr    -- : ַ, Ԥ20ֽ
ֵ
=============================================================================*/
int __stdcall TP_CancelCardEx2(char *card_snr, int waitMs);

/*=============================================================================
                        TP_GetCardSnr
;
ܣȡ(ƬΨһк)
  : 
  : card_snr    --  : ַ, Ԥ20ֽ
ֵ
=============================================================================*/
int __stdcall TP_GetCardSnr(char *card_snr);



////////////////////// ºƹлԱ ///////////////////////
/*=============================================================================
                TP_M1Active
ܣƬ(ȡ)
Ρ
  : card_snr -- , 4ֽ(ַʾΪ8ַ)
ֵ
衡Ƭ
=============================================================================*/
int __stdcall TP_M1Active(char *card_snr);

/*=============================================================================
                TP_M1AuthKey
ܣ֤ƬԿ
ΡkeyA:	    Կ, ֽ, ƬĬԿ "ffffffffffff"
		sector_no: , 1~40 
ֵ
衡֤ƬӦԿ, ֤ſԶд
=============================================================================*/
int __stdcall TP_M1AuthKey(char *keyA, UINT sector_no);

/*=============================================================================
                TP_M1SetKeyA
ܣ޸ԿA
ΡNewKeyA:	ԿA, ֽ, ַʾ(12ַ)
		sector_no:	
ֵ
衡޸ĿƬԿA, עҪAuthKey֤ԭԿ. ע⺯˳:
        TP_M1Active    TP_M1AuthKey    TP_M1SetKeyA
=============================================================================*/
int __stdcall TP_M1SetKeyA(char *newKeyA, UINT sector_no);

/*=============================================================================
                TP_M1WriteBlock
ܣд
Ρblock_no:	(һ*4 + ڿ)
		data:	Ҫд16ֽ, ַʾ(32ַ)
ֵ
衡дһ. TP_M1AuthKey֤Կ
; , 9ԶдĿŰ: 9*4  9*4+1  9*4+2,  : 36  37  38.  ע⺯˳:
        TP_M1Active    TP_M1AuthKey    TP_M1WriteBlock
=============================================================================*/
int __stdcall TP_M1WriteBlock(UINT block_no, char *data);

/*=============================================================================
                TP_M1ReadBlock
ܣ
Ρblock_no:	(һ*4 +ڿ)
  : data:	16ֽ, ַʾ(32ַ)
ֵ
衡ȡһ. TP_M1AuthKey֤Կ.  ע⺯˳:
        TP_M1Active    TP_M1AuthKey    TP_M1ReadBlock
=============================================================================*/
int __stdcall TP_M1ReadBlock(UINT block_no, char *data);


#ifdef __cplusplus
   }
#endif

#endif              // __LOCK_SDK_H__